# Faça uma função que, dada uma lista de elementos comparáveis entre si
# (ex: números), devolve o menor e o maior elemento.

def maior_menor(lista):
    maximo = lista[0]
    minimo = lista[0]
    for i in range(1, len(lista)):
        if lista[i] > maximo:
            maximo = lista[i]
        if lista[i] < minimo:
            minimo = lista[i]
    return maximo, minimo


# Faça uma função que, dados um dicionário onde as chaves são pontos
# bidimensionais e os valores são números e um ponto (x, y), encontra o valor
# do ponto mais próximo (distância Euclidiana) de (x, y) que é chave do
# dicionário.

def distancia(p1, p2):
    return ((p1[0] - p2[0])**2 + (p1[1] - p2[1])**2) ** (1 / 2)


def temperatura(temps, ponto):
    minimo = None
    for chave, valor in temps.items():
        d = distancia(chave, ponto)
        if minimo is None or minimo > d:
            minimo = d
            minimo_valor = valor
    return minimo_valor


temps = {
    (1, 2): 27,
    (3, 7): 10,
    (8, 2): 15
}
ponto = (3, 3)

print(temperatura(temps, ponto))


# Faça uma função que, dado um dicionário onde as chaves são nomes e os valores
# são listas de notas, calcula a média aritmética de cada nome, devolvendo um
# dicionário com os resultados.

notas = {
    "Ana": [10, 9, 10],
    "Beto": [7, 9, 10]
}


def media(lista):
    return sum(lista) / len(lista)


lista_media = {nome: media(lista) for nome, lista in notas.items()}


t = maior_menor([1, 3, 4, 0, 7])

print(t)
